using System;
using System.Xml.Serialization	;
using System.Drawing;

namespace Defining_Config_Info
{
	/// <summary>
	/// Summary description for ApplicationTab.
	/// </summary>
	[Serializable]
	public class ApplicationTab
	{
		private Color tabColor;
		private string label;
		private string message;

		public ApplicationTab()	{}
		public ApplicationTab (Color tabColor, string label, string message) 
		{
			this.TabColor = tabColor;
			this.Label = label;
			this.Message = message;
		}
		
		[XmlIgnore]
		public Color TabColor
		{
			get
			{
				return this.tabColor;
			}
			set
			{
				if (! value.IsEmpty)
					this.tabColor = value;
			}
		}

		[XmlElement("TabColor")]
		public string BackColor
		{
			get
			{
				ColorConverter colorConverter = new ColorConverter();
				return colorConverter.ConvertToString(TabColor);
			}
			set
			{
				if (value != null)
				{
					ColorConverter colorConverter = new ColorConverter();
					TabColor = (Color)colorConverter.ConvertFromString(value);
				}
			}
		}

		public string Label
		{
			get
			{
				return label; 
			}
			set
			{
				if (value != null)
					label = value;
			}
		}

		public string Message
		{
			get
			{
				return message;
			}
			set
			{
				if (value != null)
					message = value;
			}
		}
	}
}
