namespace Defining_Config_Info
{
    using System.Xml.Serialization;
    using System;
    
    
    /// <summary>Custom serializer for TabConfig type.</summary
    public class TabConfigSerializer : System.Xml.Serialization.XmlSerializer
    {
        
        
		TabConfigReader _reader;
		TabConfigWriter _writer;

		/// <summary>Constructs the serializer with default reader and writer instances.</summary>
		public TabConfigSerializer()
		{
		}

		/// <summary>Constructs the serializer with a pre-built reader.</summary>
		public TabConfigSerializer(TabConfigReader reader)
		{
			_reader = reader;
		}

		/// <summary>Constructs the serializer with a pre-built writer.</summary>
		public TabConfigSerializer(TabConfigWriter writer)
		{
			_writer = writer;
		}

		/// <summary>Constructs the serializer with pre-built reader and writer.</summary>
		public TabConfigSerializer(TabConfigReader reader, TabConfigWriter writer)
		{
			_reader = reader;
			_writer = writer;
		}

		/// <summary>See <see cref="XmlSerializer.CreateReader"/>.</summary>
		protected override XmlSerializationReader CreateReader()
		{
			if (_reader != null) 
				return _reader;
			else
				return new TabConfigReader();
		}

		/// <summary>See <see cref="XmlSerializer.CreateWriter"/>.</summary>
		protected override XmlSerializationWriter CreateWriter()
		{
			if (_writer != null) 
				return _writer;
			else
				return new TabConfigWriter();
		}

		/// <summary>See <see cref="XmlSerializer.Deserialize"/>.</summary>
		protected override object Deserialize(XmlSerializationReader reader)
		{
			if (!(reader is TabConfigReader))
				throw new ArgumentException("reader");

			return ((TabConfigReader)reader).Read();
		}

		/// <summary>See <see cref="XmlSerializer.Serialize"/>.</summary>
		protected override void Serialize(object o, XmlSerializationWriter writer)
		{
			if (!(writer is TabConfigWriter))
				throw new ArgumentException("writer");

			((TabConfigWriter)writer).Write((Defining_Config_Info.TabConfig)o);
		}
        public class Reader : System.Xml.Serialization.XmlSerializationReader {

        /// <remarks/>
        protected virtual Defining_Config_Info.TabConfig Read1_TabConfig(bool isNullable, bool checkType) {
            if (isNullable && ReadNull()) return null;
            if (checkType) {
                System.Xml.XmlQualifiedName t = GetXsiType();
                if (t == null || ((object) ((System.Xml.XmlQualifiedName)t).Name == (object)id1_TabConfig && (object) ((System.Xml.XmlQualifiedName)t).Namespace == (object)id2_Item))
                    ;
                else
                    throw CreateUnknownTypeException((System.Xml.XmlQualifiedName)t);
            }
            Defining_Config_Info.TabConfig o = new Defining_Config_Info.TabConfig();
            Defining_Config_Info.ApplicationTab[] a_0 = null;
            int ca_0 = 0;
            bool[] paramsRead = new bool[1];
            while (Reader.MoveToNextAttribute()) {
                if (!IsXmlnsAttribute(Reader.Name)) {
                    UnknownNode((object)o);
                }
            }
            Reader.MoveToElement();
            if (Reader.IsEmptyElement) {
                Reader.Skip();
                return o;
            }
            Reader.ReadStartElement();
            Reader.MoveToContent();
            while (Reader.NodeType != System.Xml.XmlNodeType.EndElement) {
                if (Reader.NodeType == System.Xml.XmlNodeType.Element) {
                    if (((object) Reader.LocalName == (object)id3_Tabs && (object) Reader.NamespaceURI == (object)id2_Item)) {
                        if (!ReadNull()) {
                            Defining_Config_Info.ApplicationTab[] a_0_0 = null;
                            int ca_0_0 = 0;
                            if (Reader.IsEmptyElement) {
                                Reader.Skip();
                            }
                            else {
                                Reader.ReadStartElement();
                                Reader.MoveToContent();
                                while (Reader.NodeType != System.Xml.XmlNodeType.EndElement) {
                                    if (Reader.NodeType == System.Xml.XmlNodeType.Element) {
                                        if (((object) Reader.LocalName == (object)id4_ApplicationTab && (object) Reader.NamespaceURI == (object)id2_Item)) {
                                            a_0_0 = (Defining_Config_Info.ApplicationTab[])EnsureArrayIndex(a_0_0, ca_0_0, typeof(Defining_Config_Info.ApplicationTab));a_0_0[ca_0_0++] = Read2_ApplicationTab(true, true);
                                        }
                                        else {
                                            UnknownNode(null);
                                        }
                                    }
                                    else {
                                        UnknownNode(null);
                                    }
                                    Reader.MoveToContent();
                                }
                            ReadEndElement();
                            }
                            o.@Tabs = (Defining_Config_Info.ApplicationTab[])ShrinkArray(a_0_0, ca_0_0, typeof(Defining_Config_Info.ApplicationTab), false);
                        }
                    }
                    else {
                        UnknownNode((object)o);
                    }
                }
                else {
                    UnknownNode((object)o);
                }
                Reader.MoveToContent();
            }
            ReadEndElement();
            return o;
        }

        /// <remarks/>
        protected virtual Defining_Config_Info.ApplicationTab Read2_ApplicationTab(bool isNullable, bool checkType) {
            if (isNullable && ReadNull()) return null;
            if (checkType) {
                System.Xml.XmlQualifiedName t = GetXsiType();
                if (t == null || ((object) ((System.Xml.XmlQualifiedName)t).Name == (object)id4_ApplicationTab && (object) ((System.Xml.XmlQualifiedName)t).Namespace == (object)id2_Item))
                    ;
                else
                    throw CreateUnknownTypeException((System.Xml.XmlQualifiedName)t);
            }
            Defining_Config_Info.ApplicationTab o = new Defining_Config_Info.ApplicationTab();
            bool[] paramsRead = new bool[3];
            while (Reader.MoveToNextAttribute()) {
                if (!IsXmlnsAttribute(Reader.Name)) {
                    UnknownNode((object)o);
                }
            }
            Reader.MoveToElement();
            if (Reader.IsEmptyElement) {
                Reader.Skip();
                return o;
            }
            Reader.ReadStartElement();
            Reader.MoveToContent();
            while (Reader.NodeType != System.Xml.XmlNodeType.EndElement) {
                if (Reader.NodeType == System.Xml.XmlNodeType.Element) {
                    if (!paramsRead[0] && ((object) Reader.LocalName == (object)id5_TabColor && (object) Reader.NamespaceURI == (object)id2_Item)) {
                        o.@BackColor = Reader.ReadElementString();
                        paramsRead[0] = true;
                    }
                    else if (!paramsRead[1] && ((object) Reader.LocalName == (object)id6_Label && (object) Reader.NamespaceURI == (object)id2_Item)) {
                        o.@Label = Reader.ReadElementString();
                        paramsRead[1] = true;
                    }
                    else if (!paramsRead[2] && ((object) Reader.LocalName == (object)id7_Message && (object) Reader.NamespaceURI == (object)id2_Item)) {
                        o.@Message = Reader.ReadElementString();
                        paramsRead[2] = true;
                    }
                    else {
                        UnknownNode((object)o);
                    }
                }
                else {
                    UnknownNode((object)o);
                }
                Reader.MoveToContent();
            }
            ReadEndElement();
            return o;
        }

        /// <remarks/>
        protected virtual System.Object Read3_Object(bool isNullable, bool checkType) {
            if (isNullable && ReadNull()) return null;
            if (checkType) {
                System.Xml.XmlQualifiedName t = GetXsiType();
                if (t == null)
                    return ReadTypedPrimitive(new System.Xml.XmlQualifiedName("anyType", "http://www.w3.org/2001/XMLSchema"));
                else if (((object) ((System.Xml.XmlQualifiedName)t).Name == (object)id1_TabConfig && (object) ((System.Xml.XmlQualifiedName)t).Namespace == (object)id2_Item))
                    return Read1_TabConfig(isNullable, false);
                else if (((object) ((System.Xml.XmlQualifiedName)t).Name == (object)id4_ApplicationTab && (object) ((System.Xml.XmlQualifiedName)t).Namespace == (object)id2_Item))
                    return Read2_ApplicationTab(isNullable, false);
                else if (((object) ((System.Xml.XmlQualifiedName)t).Name == (object)id8_ArrayOfApplicationTab && (object) ((System.Xml.XmlQualifiedName)t).Namespace == (object)id2_Item)) {
                    Defining_Config_Info.ApplicationTab[] a = null;
                    if (!ReadNull()) {
                        Defining_Config_Info.ApplicationTab[] z_0_0 = null;
                        int cz_0_0 = 0;
                        if (Reader.IsEmptyElement) {
                            Reader.Skip();
                        }
                        else {
                            Reader.ReadStartElement();
                            Reader.MoveToContent();
                            while (Reader.NodeType != System.Xml.XmlNodeType.EndElement) {
                                if (Reader.NodeType == System.Xml.XmlNodeType.Element) {
                                    if (((object) Reader.LocalName == (object)id4_ApplicationTab && (object) Reader.NamespaceURI == (object)id2_Item)) {
                                        z_0_0 = (Defining_Config_Info.ApplicationTab[])EnsureArrayIndex(z_0_0, cz_0_0, typeof(Defining_Config_Info.ApplicationTab));z_0_0[cz_0_0++] = Read2_ApplicationTab(true, true);
                                    }
                                    else {
                                        UnknownNode(null);
                                    }
                                }
                                else {
                                    UnknownNode(null);
                                }
                                Reader.MoveToContent();
                            }
                        ReadEndElement();
                        }
                        a = (Defining_Config_Info.ApplicationTab[])ShrinkArray(z_0_0, cz_0_0, typeof(Defining_Config_Info.ApplicationTab), false);
                    }
                    return a;
                }
                else
                    return ReadTypedPrimitive((System.Xml.XmlQualifiedName)t);
            }
            System.Object o = new System.Object();
            bool[] paramsRead = new bool[0];
            while (Reader.MoveToNextAttribute()) {
                if (!IsXmlnsAttribute(Reader.Name)) {
                    UnknownNode((object)o);
                }
            }
            Reader.MoveToElement();
            if (Reader.IsEmptyElement) {
                Reader.Skip();
                return o;
            }
            Reader.ReadStartElement();
            Reader.MoveToContent();
            while (Reader.NodeType != System.Xml.XmlNodeType.EndElement) {
                if (Reader.NodeType == System.Xml.XmlNodeType.Element) {
                    UnknownNode((object)o);
                }
                else {
                    UnknownNode((object)o);
                }
                Reader.MoveToContent();
            }
            ReadEndElement();
            return o;
        }

        protected override void InitCallbacks() {
        }

        protected internal object Read5_TabConfig() {
            object o = null;
            Reader.MoveToContent();
            if (Reader.NodeType == System.Xml.XmlNodeType.Element) {
                if (((object) Reader.LocalName == (object)id1_TabConfig && (object) Reader.NamespaceURI == (object)id2_Item)) {
                    o = Read1_TabConfig(true, true);
                }
                else {
                    throw CreateUnknownNodeException();
                }
            }
            else {
                UnknownNode(null);
            }
            return (object)o;
        }

        System.String id2_Item;
        System.String id5_TabColor;
        System.String id6_Label;
        System.String id4_ApplicationTab;
        System.String id7_Message;
        System.String id3_Tabs;
        System.String id1_TabConfig;
        System.String id8_ArrayOfApplicationTab;

        protected override void InitIDs() {
            id2_Item = Reader.NameTable.Add(@"");
            id5_TabColor = Reader.NameTable.Add(@"TabColor");
            id6_Label = Reader.NameTable.Add(@"Label");
            id4_ApplicationTab = Reader.NameTable.Add(@"ApplicationTab");
            id7_Message = Reader.NameTable.Add(@"Message");
            id3_Tabs = Reader.NameTable.Add(@"Tabs");
            id1_TabConfig = Reader.NameTable.Add(@"TabConfig");
            id8_ArrayOfApplicationTab = Reader.NameTable.Add(@"ArrayOfApplicationTab");
        }
    }

        public class Writer : System.Xml.Serialization.XmlSerializationWriter {

        void Write1_TabConfig(string n, string ns, Defining_Config_Info.TabConfig o, bool isNullable, bool needType) {
            if ((object)o == null) {
                if (isNullable) WriteNullTagLiteral(n, ns);
                return;
            }
            if (!needType) {
                System.Type t = o.GetType();
                if (t == typeof(Defining_Config_Info.TabConfig))
                    ;
                else {
                    throw CreateUnknownTypeException(o);
                }
            }
            WriteStartElement(n, ns, o);
            if (needType) WriteXsiType(@"TabConfig", @"");
            {
                Defining_Config_Info.ApplicationTab[] a = (Defining_Config_Info.ApplicationTab[])((Defining_Config_Info.ApplicationTab[])o.@Tabs);
                if (a != null){
                    WriteStartElement(@"Tabs", @"");
                    for (int ia = 0; ia < a.Length; ia++) {
                        Write2_ApplicationTab(@"ApplicationTab", @"", ((Defining_Config_Info.ApplicationTab)a[ia]), true, false);
                    }
                    WriteEndElement();
                }
            }
            WriteEndElement(o);
        }

        void Write2_ApplicationTab(string n, string ns, Defining_Config_Info.ApplicationTab o, bool isNullable, bool needType) {
            if ((object)o == null) {
                if (isNullable) WriteNullTagLiteral(n, ns);
                return;
            }
            if (!needType) {
                System.Type t = o.GetType();
                if (t == typeof(Defining_Config_Info.ApplicationTab))
                    ;
                else {
                    throw CreateUnknownTypeException(o);
                }
            }
            WriteStartElement(n, ns, o);
            if (needType) WriteXsiType(@"ApplicationTab", @"");
            WriteElementString(@"TabColor", @"", ((System.String)o.@BackColor));
            WriteElementString(@"Label", @"", ((System.String)o.@Label));
            WriteElementString(@"Message", @"", ((System.String)o.@Message));
            WriteEndElement(o);
        }

        void Write3_Object(string n, string ns, System.Object o, bool isNullable, bool needType) {
            if ((object)o == null) {
                if (isNullable) WriteNullTagLiteral(n, ns);
                return;
            }
            if (!needType) {
                System.Type t = o.GetType();
                if (t == typeof(System.Object))
                    ;
                else if (t == typeof(Defining_Config_Info.TabConfig)) {
                    Write1_TabConfig(n, ns, (Defining_Config_Info.TabConfig)o, isNullable, true);
                    return;
                }
                else if (t == typeof(Defining_Config_Info.ApplicationTab)) {
                    Write2_ApplicationTab(n, ns, (Defining_Config_Info.ApplicationTab)o, isNullable, true);
                    return;
                }
                else if (t == typeof(Defining_Config_Info.ApplicationTab[])) {
                    Writer.WriteStartElement(n, ns);
                    WriteXsiType(@"ArrayOfApplicationTab", @"");
                    {
                        Defining_Config_Info.ApplicationTab[] a = (Defining_Config_Info.ApplicationTab[])o;
                        if (a != null) {
                            for (int ia = 0; ia < a.Length; ia++) {
                                Write2_ApplicationTab(@"ApplicationTab", @"", ((Defining_Config_Info.ApplicationTab)a[ia]), true, false);
                            }
                        }
                    }
                    Writer.WriteEndElement();
                    return;
                }
                else {
                    WriteTypedPrimitive(n, ns, o, true);
                    return;
                }
            }
            WriteStartElement(n, ns, o);
            WriteEndElement(o);
        }

        protected override void InitCallbacks() {
        }

        protected internal void Write4_TabConfig(object o) {
            WriteStartDocument();
            if (o == null) {
                WriteNullTagLiteral(@"TabConfig", @"");
                return;
            }
            TopLevelElement();
            Write1_TabConfig(@"TabConfig", @"", ((Defining_Config_Info.TabConfig)o), true, false);
        }
    }

    /// <remarks/>
	}
    
    public class TabConfigReader : TabConfigSerializer.Reader
    {
        
        
		/// <remarks/>
		protected override Defining_Config_Info.TabConfig Read1_TabConfig(bool isNullable, bool checkType)
		{
			Defining_Config_Info.TabConfig obj = base.Read1_TabConfig(isNullable, checkType);
			TabConfigDeserializedHandler handler = TabConfigDeserialized;
			if (handler != null)
				handler(obj);

			return obj;
		}
        
		/// <remarks/>
		protected override Defining_Config_Info.ApplicationTab Read2_ApplicationTab(bool isNullable, bool checkType)
		{
			Defining_Config_Info.ApplicationTab obj = base.Read2_ApplicationTab(isNullable, checkType);
			ApplicationTabDeserializedHandler handler = ApplicationTabDeserialized;
			if (handler != null)
				handler(obj);

			return obj;
		}
        
		/// <summary>Reads an object of type Defining_Config_Info.TabConfig.</summary>
		internal Defining_Config_Info.TabConfig Read()
		{
			return (Defining_Config_Info.TabConfig) Read5_TabConfig();
		}
        /// /// <remarks/>
        public event TabConfigDeserializedHandler TabConfigDeserialized;
        
        /// /// <remarks/>
        public event ApplicationTabDeserializedHandler ApplicationTabDeserialized;
    }
    
    /// /// <remarks/>
    public delegate void TabConfigDeserializedHandler(Defining_Config_Info.TabConfig tabConfig);
    
    /// /// <remarks/>
    public delegate void ApplicationTabDeserializedHandler(Defining_Config_Info.ApplicationTab applicationTab);
    
    public class TabConfigWriter : TabConfigSerializer.Writer
    {
        
        
		/// <summary>Writes an object of type Defining_Config_Info.TabConfig.</summary>
		internal void Write(Defining_Config_Info.TabConfig obj)
		{
			Write4_TabConfig(obj);
		}}
}

