using System;
using System.Configuration;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using TabConfiguration;
using Microsoft.Practices.EnterpriseLibrary.Configuration;

namespace Defining_Config_Info
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmConfiglnfo : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl tabs;
		private TabConfig configTabs;
		private System.Windows.Forms.ContextMenu menuTab;
		private System.Windows.Forms.MenuItem mnuChangeColor;
		private System.Windows.Forms.MenuItem mnuSetMessage;
		private System.Windows.Forms.MenuItem mnuRename;
		private System.Windows.Forms.ColorDialog colorDialog1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmConfiglnfo()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabs = new System.Windows.Forms.TabControl();
			this.menuTab = new System.Windows.Forms.ContextMenu();
			this.mnuChangeColor = new System.Windows.Forms.MenuItem();
			this.mnuRename = new System.Windows.Forms.MenuItem();
			this.mnuSetMessage = new System.Windows.Forms.MenuItem();
			this.colorDialog1 = new System.Windows.Forms.ColorDialog();
			this.SuspendLayout();
			// 
			// tabs
			// 
			this.tabs.ContextMenu = this.menuTab;
			this.tabs.Location = new System.Drawing.Point(0, 0);
			this.tabs.Multiline = true;
			this.tabs.Name = "tabs";
			this.tabs.SelectedIndex = 0;
			this.tabs.Size = new System.Drawing.Size(624, 200);
			this.tabs.SizeMode = System.Windows.Forms.TabSizeMode.FillToRight;
			this.tabs.TabIndex = 0;
			// 
			// menuTab
			// 
			this.menuTab.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuChangeColor,
																					this.mnuRename,
																					this.mnuSetMessage});
			// 
			// mnuChangeColor
			// 
			this.mnuChangeColor.Index = 0;
			this.mnuChangeColor.Text = "Change Color";
			this.mnuChangeColor.Click += new System.EventHandler(this.mnuChangeColor_Click);
			// 
			// mnuRename
			// 
			this.mnuRename.Index = 1;
			this.mnuRename.Text = "Rename";
			this.mnuRename.Click += new System.EventHandler(this.mnuRename_Select);
			// 
			// mnuSetMessage
			// 
			this.mnuSetMessage.Index = 2;
			this.mnuSetMessage.Text = "Set message";
			this.mnuSetMessage.Click += new System.EventHandler(this.mnuSetMessage_Click);
			// 
			// frmConfiglnfo
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(352, 198);
			this.Controls.Add(this.tabs);
			this.Name = "frmConfiglnfo";
			this.Text = "Using Configuration Info";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmConfiglnfo_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmConfiglnfo());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			configTabs = LoadTabConfiguration();
			CreateTabs();
		}

		private void CreateTabs()
		{
			//if no tabs exist, lets add three
			if (configTabs.Tabs.Length == 0)
			{
				for(int i=1; i <= 3; i++)
				{
					string tabName = String.Format("Tab{0}",i.ToString());
					configTabs.AddTab(tabName, Color.Empty, String.Format("This is {0}",tabName));
				}
			}

			foreach (ApplicationTab tab in configTabs.Tabs)
				AddTabToForm(tab.Label, tab.TabColor, tab.Message);

		}

		private void AddTabToForm(string label, Color backColor, string message)
		{
			TabPage tabPage = new TabPage(label);
			Label tabbedMessage = new Label();
			tabbedMessage.Text = message;
			tabPage.Controls.Add(tabbedMessage);
			tabPage.BackColor = backColor;
			tabs.Controls.Add(tabPage);
		}

		private TabConfig LoadTabConfiguration()
		{
			TabConfig appConfig;
			try
			{
				object configInfo = ConfigurationManager.GetConfiguration("TabConfig");
				if (configInfo is TabConfig)
					appConfig = configInfo as TabConfig;
				else
				{
					appConfig = new TabConfig();
				}
				return appConfig;
			}
			catch (ConfigurationException configEx)	// config info does not exist
			{
				appConfig = new TabConfig();
				return appConfig;
			}			
			catch (Exception ex)
			{
				throw new ConfigurationException("Could not retrieve configuration data for tabs",ex);
			}	
		}

		private void frmConfiglnfo_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			ConfigurationManager.WriteConfiguration("TabConfig",configTabs);	
		}

		private void mnuRename_Select(object sender, System.EventArgs e)
		{
			TabPage selectedTab = tabs.SelectedTab;
			if (selectedTab != null)
			{
				ChangeTextForm frmChangeText = new ChangeTextForm();
				frmChangeText.Text = "Set Tab Label";
				frmChangeText.LabelMessage = "Please enter the new label for this tab:";
				DialogResult dlgResult = frmChangeText.ShowDialog();
				if (dlgResult == DialogResult.OK)
				{
					selectedTab.Text = configTabs.Tabs[tabs.SelectedIndex].Label = frmChangeText.NewText;
				}
			}
		}

		private void mnuChangeColor_Click(object sender, System.EventArgs e)
		{
			TabPage selectedTab = tabs.SelectedTab;
			if (selectedTab != null)
			{
				DialogResult dialogResult = colorDialog1.ShowDialog();
				if (dialogResult == DialogResult.OK)
				{
					selectedTab.BackColor = configTabs.Tabs[tabs.SelectedIndex].TabColor =	colorDialog1.Color;				
				}
			}
		}

		private void mnuSetMessage_Click(object sender, System.EventArgs e)
		{
			TabPage selectedTab = tabs.SelectedTab;
			if (selectedTab != null)
			{
				ChangeTextForm frmChangeText = new ChangeTextForm();
				frmChangeText.Text = "Set Tab Message";
				frmChangeText.LabelMessage = "Please enter the new text for the message:";
				DialogResult dlgResult = frmChangeText.ShowDialog();
				if (dlgResult == DialogResult.OK)
				{
					selectedTab.Controls[0].Text = configTabs.Tabs[tabs.SelectedIndex].Message = frmChangeText.NewText;
				}
			}
	}


	}
}
