using System;
using System.Xml.Serialization;
using Microsoft.Practices.EnterpriseLibrary.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Transformer;

namespace EnterpriseLibrary.Extensions.Configuration
{
    [XmlRoot("dataTransformer", Namespace=ConfigurationSettings.ConfigurationNamespace)]
    public class MvpSerializerTransformerData : TransformerData
    {
		private string strSerializer;

        public MvpSerializerTransformerData() : this(string.Empty)
        {
        }

        public MvpSerializerTransformerData(string name) : this(String.Empty, name)
        {
        }

		public MvpSerializerTransformerData(string strSerializer, string name) : base(name)
		{
			this.strSerializer = strSerializer;
		}

		[XmlAttribute("serializationType")]
        public string SerializationType
        {
            get { return strSerializer; }
			set { strSerializer = value; }
        }

		[XmlIgnore]
        public override string TypeName
        {
            get { return typeof(MvpSerializerTransformer).AssemblyQualifiedName; }
            set
            {
            }
        }

        public override object Clone()
        {
            MvpSerializerTransformerData transformerData = new MvpSerializerTransformerData(Name);
            return transformerData;
        }
    }
}