using System;
using Microsoft.Practices.EnterpriseLibrary.Configuration;

namespace EnterpriseLibrary.Extensions
{
    [Serializable]
    public class ConfigurationDatabaseChangedEventArgs : ConfigurationChangedEventArgs
    {
		private readonly string strDbInstance;
		private readonly string strGetConfig;
		private readonly string strSetConfig;

		public ConfigurationDatabaseChangedEventArgs(string strDbInstance, string strGetConfig, string strSetConfig, string sectionName) : base(String.Empty,sectionName)
        {
			this.strDbInstance = strDbInstance;
			this.strGetConfig = strGetConfig;
			this.strSetConfig = strSetConfig;
		}
		
		public string DatabaseInstance
		{
			get { return this.strDbInstance; }
		}

		public string GetConfigStoredProc
		{
			get { return this.strGetConfig; }
		}

		public string SetConfigStoredProc
		{
			get { return this.strSetConfig; }
		}
	}
}