using System;
using Microsoft.Practices.EnterpriseLibrary.Configuration;

namespace EnterpriseLibrary.Extensions
{
    public delegate void ConfigurationDatabaseChangingEventHandler(object sender, ConfigurationChangingEventArgs e);

    [Serializable]
    public class ConfigurationDatabaseChangingEventArgs : ConfigurationChangingEventArgs
    {
		private readonly string strDbInstance;
		private readonly string strGetConfig;
		private readonly string strSetConfig;

		public ConfigurationDatabaseChangingEventArgs(string strDbInstance, string strGetConfig, string strSetConfig, string sectionName, object oldValue, object newValue) : base(String.Empty,sectionName, oldValue, newValue)
        {
			this.strDbInstance = strDbInstance;
			this.strGetConfig = strGetConfig;
			this.strSetConfig = strSetConfig;
		}

		public string DatabaseInstance
		{
			get { return this.strDbInstance; }
		}

		public string GetConfigStoredProc
		{
			get { return this.strGetConfig; }
		}

		public string SetConfigStoredProc
		{
			get { return this.strSetConfig; }
		}
	}
}