using System;
using System.Configuration;
using System.Globalization;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using Microsoft.Practices.EnterpriseLibrary.Common;
using Microsoft.Practices.EnterpriseLibrary.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Transformer;

namespace TabConfiguration
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class TabConfigTranformer : TransformerProvider
	{
		public override object Serialize(object value)
		{
			ArgumentValidation.CheckForNullReference(value, "value");
			ArgumentValidation.CheckExpectedType(value, typeof(TabConfig));
			
//			StringWriter stringWriter = new StringWriter(CultureInfo.InvariantCulture);
//			XmlTextWriter xmlTextWriter = new XmlTextWriter(stringWriter);
//			XmlDocument doc = new XmlDocument();
//			XmlSerializer serializer = new XmlSerializer(typeof (TabConfig));
//			try
//			{
//				serializer.Serialize(xmlTextWriter, value);
//				xmlTextWriter.Flush();
//				doc.LoadXml(stringWriter.ToString());
//			}
//			finally
//			{
//				xmlTextWriter.Close();
//				stringWriter.Close();
//			}
//			return doc.DocumentElement;			
			
			byte[] buffer = null;

			using (MemoryStream ms = new MemoryStream())
			{
				BinaryFormatter formatter = new BinaryFormatter();
				formatter.Serialize(ms, value);
				buffer = new byte[ms.Length];
				ms.Position = 0;
				ms.Read(buffer, 0, (int)ms.Length);
				ms.Flush();
			}
			
			return buffer;
		}
	
		public override object Deserialize(object section)
		{
			object returnConfigObject = null;
			BinaryFormatter formatter = new BinaryFormatter();

			using (MemoryStream ms = new MemoryStream((byte[])section))
			{
				returnConfigObject = formatter.Deserialize(ms);
			}

			return returnConfigObject;
			
			
//			ArgumentValidation.CheckForNullReference(section, "section");
//			ArgumentValidation.CheckExpectedType(section, typeof(XmlNode));
//
//			XmlNode serializationNode = (XmlNode)section;
//
//			if (serializationNode == null)
//			{
//				throw new ConfigurationException(SR.ExceptionNotInSerializedObj);
//			}
//			if (serializationNode.ChildNodes.Count == 0)
//			{
//				throw new ConfigurationException(SR.ExceptionSerializedObjectMissing);
//			}
//			XmlSerializer serializer = new XmlSerializer(typeof (TabConfig));
//			try
//			{
//				return serializer.Deserialize(new XmlNodeReader(serializationNode.ChildNodes[0]));
//			}
//			catch (InvalidOperationException e)
//			{
//				string message = e.Message;
//				if (null != e.InnerException)
//				{
//					message = String.Concat(message, " ", e.InnerException.Message);
//				}
//				throw new ConfigurationException(message, e);
//			}
			
		}
	
		public override void Initialize(ConfigurationView configurationView)
		{
		}
	}
}
