using System;
using Microsoft.Practices.EnterpriseLibrary.Caching;

namespace XmlFileBackingStore.Tests
{
    /// <summary>
    /// This class reflects an expiration policy of always being expired.
    /// </summary>
    [Serializable]
    public class AlwaysExpired : ICacheItemExpiration
    {
        /// <summary>
        /// Always returns true.
        /// </summary>
        /// <returns>True always</returns>
        public bool HasExpired()
        {
            return true;
        }

        /// <summary>
        ///  Not used
        /// </summary>
        public void Notify()
        {
        }

        /// <summary>
        ///  Not used
        /// </summary>
        /// <param name="owningCacheItem">Not used</param>
        public void Initialize(CacheItem owningCacheItem)
        {
        }
    }
}
