
using NUnit.Framework;
using Microsoft.Practices.EnterpriseLibrary.Configuration;

namespace XmlFileBackingStore.Tests
{
    [TestFixture]
    public class ConfigurationContextFixtureBase
    {
        private ConfigurationContext context;

        [TestFixtureSetUp]
        public virtual void FixtureSetup()
        {
            context = ConfigurationManager.GetCurrentContext();
        }

        [TestFixtureTearDown]
        public virtual void FixtureTeardown()
        {
			if (context == null) return;
            context.Dispose();
            context = null;
        }

        public virtual ConfigurationContext Context
        {
            get { return context; }
        }
    }
}