using System;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using Microsoft.Practices.EnterpriseLibrary.Caching.Configuration;
using XmlFileBackingStore.Configuration;
using NUnit.Framework;

namespace XmlFileBackingStore.Tests
{
	[TestFixture]
	public class XmlFileCacheStorageDataFixture
	{
		private string configurationSection =
			"<cacheStorage " +
			"xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" " +
			"xmlns=\"" + CacheManagerSettings.ConfigurationNamespace + "\" " +
			"xsi:type=\"xmlFileCacheStorageData\" " +
			"name=\"inIsolatedStorage\" " +
			"xmlFileName=\"cacheditems.xml\" " +
			"partitionName=\"Partition1\"" +
			"/>";

		[Test]
		public void CanReadCacheStorageObject()
		{
			XmlTextReader xmlReader = new XmlTextReader(new StringReader(configurationSection));
			XmlSerializer xmlSerializer = new XmlSerializer(typeof(xmlFileCacheStorageData));
			xmlFileCacheStorageData objectFromConfiguration = xmlSerializer.Deserialize(xmlReader) as xmlFileCacheStorageData;

			Assert.AreEqual("inIsolatedStorage", objectFromConfiguration.Name);
			Assert.IsNotNull(objectFromConfiguration.TypeName);
			Assert.IsNotNull(Type.GetType(objectFromConfiguration.TypeName));
			Assert.AreEqual("cacheditems.xml", objectFromConfiguration.XmlFileName);
			Assert.AreEqual("Partition1", objectFromConfiguration.PartitionName);
		}
	}
}
