using System;
using System.ComponentModel;

namespace XmlFileBackingStore.Configuration.Design
{
    /// <devdoc>
    /// Represents a localized vertion of a DescriptionAttribute. It uses the local strings resouce to get its description.
    /// This class cannot be inherited from 
    /// </devdoc>
    [AttributeUsage(AttributeTargets.All)]
    internal sealed class SRDescriptionAttribute : DescriptionAttribute
    {
        private bool replaced;

        public SRDescriptionAttribute(string description) : base(description)
        {
        }

        public override string Description
        {
            get
            {
                if (!this.replaced)
                {
                    this.replaced = true;
                    base.DescriptionValue = SR.Keys.GetString(base.Description);
                }
                return base.Description;
            }
        }

    }
}