using System;
using System.Xml.Serialization;
using Microsoft.Practices.EnterpriseLibrary.Caching.Configuration;

namespace XmlFileBackingStore.Configuration
{
	/// <summary>
	/// Summary description for xmlFileCacheStorage.
	/// </summary>
	[XmlRoot("cacheStorage", Namespace=CacheManagerSettings.ConfigurationNamespace)]
	public class xmlFileCacheStorageData : CacheStorageData
	{
		private string xmlFileName;
		private string partitionName;
		
		public xmlFileCacheStorageData()
		{
		}
		
		public xmlFileCacheStorageData(string name) : base(name)
		{
			
		}
		
		public xmlFileCacheStorageData(string name, string xmlFileName, string partitionName) : base(name)
		{
			this.XmlFileName = xmlFileName;
			this.partitionName = partitionName;
		}

		[XmlAttribute("xmlFileName")]
		public string XmlFileName
		{
			get { return xmlFileName; }
			set { xmlFileName = value; }
		}

		/// <summary>
		/// Name of the an extra extension that will be added to the file name to store this provider's data. This 
		/// field allows different applications to share the same filename, preventing any modification of 
		/// one application's data by a provider from another application.
		/// </summary>
		[XmlAttribute("partitionName")]
		public string PartitionName
		{
			get { return partitionName; }
			set { partitionName = value; }
		}

		/// <summary>
		/// String representation of the type of the DataBackingStore object to instantiate
		/// </summary>
		[XmlIgnore]
		public override string TypeName
		{
			get { return typeof(XmlFileBackingStore).AssemblyQualifiedName; }
			set
			{
			}
		}

	}
}
