
#if    UNIT_TESTS
using System;
using System.IO;
using System.Text;
using NUnit.Framework;

using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Tests;

namespace ExtendedExceptionHandling.Tests
{
    [TestFixture]
    public class CSVExceptionFormatterFixture
    {
        [Test]
        public void CreateTest()
        {
            TextWriter writer = new StringWriter(TestUtility.DefaultCulture);
            Exception exception = new Exception();
            CSVExceptionFormatter formatter = new CSVExceptionFormatter(writer, exception);

            Assert.AreSame(writer, formatter.Writer);
            Assert.AreSame(exception, formatter.Exception);
        }

        [Test]
        public void SimpleFormatterTest()
        {
            StringBuilder sb = new StringBuilder();
            StringWriter writer = new StringWriter(sb, TestUtility.DefaultCulture);

            Exception exception = new MockException();
			Exception exception2 = new ApplicationException("new exception message",exception);

            CSVExceptionFormatter formatter = new CSVExceptionFormatter(writer, exception2);

            // Nothing should be written until Format() is called
            Assert.IsTrue(sb.Length == 0);

            // Format the exception
            formatter.Format();

			File.CreateText("C:\\Documents and Settings\\lfenster\\Desktop\\logging\\test.csv").Write(sb.ToString());

            // Not much of a test, but at least we can tell if _something_ got written
            // to the underlying StringBuilder
            Assert.IsTrue(sb.Length > 0);
        }
    }
}

#endif