#if    UNIT_TESTS
using System;
using System.Configuration;
using System.IO;
using NUnit.Framework;

using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Tests;

namespace ExtendedExceptionHandling.Tests
{
    [TestFixture]
    public class ContextualWrapHandlerFixture
    {
		private static bool HandleException(Exception ex, string strNewExceptionMessage, string strPolicy)
		{
			return ExceptionPolicy.HandleException(new WrapperException(strNewExceptionMessage, ex),strPolicy);
		}

		[Test]
		public void ContextualWrapHandlerSqlTest()
		{
			string strTestMessage = "An exception was thrown within the data layer trying to retrieve the Announcements Dataset";	//: {handlingInstanceID}";

			try
			{
				System.Data.SqlClient.SqlConnection conn = new System.Data.SqlClient.SqlConnection("Integrated Security=SSPI;Initial Catalog=baddb;Data Source=(local);");
				conn.Open();
			}
			catch (System.Data.SqlClient.SqlException sqlException)
			{
				try
				{
					HandleException(sqlException, strTestMessage, "Wrap Policy");
				}
				catch (Exception wrappedException)
				{
					Assert.AreEqual(typeof(ApplicationException), wrappedException.GetType());
					Assert.AreEqual(strTestMessage, wrappedException.Message);
					Assert.AreEqual(typeof(System.Data.SqlClient.SqlException), wrappedException.InnerException.GetType());
				}
			}
		}
	}
  }

#endif