using System;
using System.Runtime.Serialization;

namespace ExtendedExceptionHandling
{
	/// <summary>
	/// Summary description for WrapperException.
	/// </summary>
	[Serializable()]
	public class WrapperException : ApplicationException	
	{
		
		// Default constructor
		public WrapperException()
		{
		}
		// Constructor with exception message
		public WrapperException(string message) : base(message)
		{}

		// Constructor with message and inner exception
		public WrapperException(string message, Exception inner) : base(message, inner)
		{}
		
		// Protected constructor to de-serialize data
		public WrapperException(SerializationInfo info, StreamingContext context) : 	base(info,context)
		{
		}
		
		public override void GetObjectData (System.Runtime.Serialization.SerializationInfo info, System.Runtime.Serialization.StreamingContext context)
		{
			//Persist any values into the serialized data stream here (e.g., info.AddValue("m_strMachineName", "My machine name"))
			base.GetObjectData(info, context);
		}
	}
}
