using System;
using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Data.Configuration;
using DatabaseDistributor.Configuration;

namespace DatabaseDistributor
{
    /// <summary>
    /// <para>Represents a view for navigating the <see cref="DatabaseSettings"/> configuration data.</para>
    /// </summary>
	public class DatabaseDistributorConfigurationView : ConfigurationView
    {
        /// <summary>
        /// <para>Initialize a new instance of the <see cref="DatabaseConfigurationView"/> class with a <see cref="ConfigurationContext"/> object.</para>
        /// </summary>
        /// <param name="configurationContext">
        /// <para>A <see cref="ConfigurationContext"/> object.</para>
        /// </param>
        public DatabaseDistributorConfigurationView(ConfigurationContext configurationContext) : base(configurationContext)
        {
        }

        /// <summary>
        /// <para>Gets the <see cref="DatabaseDistributorSettings"/> configuration data.</para>
        /// </summary>
        /// <returns>
        /// <para>The <see cref="DatabaseDistributorSettings"/> configuration data.</para>
        /// </returns>
        public virtual DatabaseDistributorSettings GetDatabaseDistributorSettings()
		{
            return (DatabaseDistributorSettings)ConfigurationContext.GetConfiguration(DatabaseDistributorSettings.SectionName);
        }
       
    }
}