#if  UNIT_TESTS
using System;

namespace DatabaseDistributor.Tests
{
    internal class MockDatabaseListener : DatabaseListener
    {
        public bool ExceptionOnStart = false;
        public bool ExceptionOnStop = false;
        public bool StopReturnsFalse = false;

        public bool StartCalled = false;
        public bool StopCalled = false;

        public MockDatabaseListener(DatabaseDistributorService logDistributor, int timerInterval)
            : base(logDistributor, timerInterval)
        {
        }

        public override void StartListener()
        {
			base.StartListener();
            StartCalled = true;
            if (ExceptionOnStart)
            {
                throw new Exception("simulated exception");
            }
        }

        public override bool StopListener()
        {
			base.StopListener();
			StopCalled = true;
            if (ExceptionOnStop)
            {
                throw new Exception("simulated exception");
            }
            if (StopReturnsFalse)
            {
                return false;
            }
            return true;
        }
    }
}

#endif