using System.ComponentModel;
using System.Drawing.Design;
using System.Diagnostics;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation;
using Microsoft.Practices.EnterpriseLibrary.Security.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Security.Configuration.Design;

namespace Authentication.Providers.ADAuthenticationProvider.Configuration.Design
{
    /// <summary>
    /// The design time representation of the runtime 
    /// <see cref="ADAuthenticationProvider"/> class.
    /// </summary>
    public class ActiveDirectoryAuthenticationProviderNode : AuthenticationProviderNode
    {
        private ADAuthenticationProviderData adAuthProviderData;

        /// <summary>
        /// Initializes a new instance of the <see cref="ActiveDirectoryAuthenticationProviderNode"/> class.
        /// </summary>
        public ActiveDirectoryAuthenticationProviderNode() : this(new ADAuthenticationProviderData("Active Directory Authentication Provider"))	//, string.Empty, string.Empty, string.Empty))
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ActiveDirectoryAuthenticationProviderNode"/>
        /// class with the specified <see cref="ADAuthenticationProvider"/>.
        /// </summary>
        /// <param name="adAuthProviderData">A <see cref="ADAuthenticationProviderData"/> object.</param>
        public ActiveDirectoryAuthenticationProviderNode(ADAuthenticationProviderData adAuthProviderData) : base(adAuthProviderData)
        {
            this.adAuthProviderData = adAuthProviderData;
        }

    }
}