
using System.Xml.Serialization;
using Microsoft.Practices.EnterpriseLibrary.Security.Configuration;

//namespace Microsoft.Practices.EnterpriseLibrary.Security.ActiveDirectory.Configuration
namespace Authentication.Providers.ADAuthenticationProvider.Configuration
{
	/// <summary>
	/// Configuration data for the Active Directory Authentication Provider.
	/// </summary>
	[XmlRoot("authenticationProvider", Namespace=SecuritySettings.ConfigurationNamespace)]
	public class ADAuthenticationProviderData : AuthenticationProviderData
    {
        /// <summary>
        /// Default Constructor.
        /// </summary>
        public ADAuthenticationProviderData()
        {
        }
        /// <summary>
        /// Initializes a new instance of the  <see cref="ADAuthenticationProviderData"/> class with the specified name.
        /// </summary>
        /// <param name="name">The name of the provider</param>
		//public ADAuthenticationProviderData(string name, string userPartition, string adminAccount, string adminPassword) : base(name)
		public ADAuthenticationProviderData(string name) : base(name)
        {
        }

        /// <summary>
        /// <para>Gets or sets the <see cref="System.Type"/> name of the provider.</para>
        /// </summary>
        /// <value>
        /// <para>The type name of the provider. The default is an empty string.</para>
        /// </value>
        public override string TypeName
        {
            get { return typeof(ADAuthenticationProvider).AssemblyQualifiedName; }
            set
            {
            }
        }
	}
}
