using System;
using System.Security;
using System.Security.Principal;
using System.Security.Permissions;

namespace EAF.Security.AuthorizationProviderPermissions
{
	/// <summary>
	/// Summary description for AuthorizationProviderPermissionAttribute.
	/// </summary>
	[AttributeUsage(AttributeTargets.All),Serializable()]
	public class AuthorizationProviderPermissionAttribute : CodeAccessSecurityAttribute
	{

		#region "Fields"
			private bool authenticated;
			private string providerName;
			private string rule;
		#endregion		
		
		public AuthorizationProviderPermissionAttribute(SecurityAction action) : base(action)
		{
			authenticated = true;
			providerName = null;
			rule = null;
		}

		public override IPermission CreatePermission()
		{
//			if (this.Unrestricted)
//			{
//				return new AuthorizationProviderPermission(PermissionState.Unrestricted);
//			}
			return new AuthorizationProviderPermission(this.ProviderName,this.Rule,this.Authenticated);
		}

		public bool Authenticated 
		{ 
			get {return this.authenticated;}
			set {this.authenticated = value; }
		}

		public string ProviderName 
		{ 
			get {return this.providerName;}
			set {this.providerName = value;}
		}
		
		public string Rule 
		{ 
			get {return this.rule;}
			set {this.rule = value; }
		}
	}

}
