using System;
using System.ComponentModel;

namespace EAF.Security.PortalProfile.Configuration.Design
{
    /// <devdoc>
    /// Represents a localized vertion of a CategoryAttribute. It uses the local string resources for localization.
    /// This class cannot be inherited from
    /// </devdoc>
    [AttributeUsage(AttributeTargets.All)]
    internal sealed class SRCategoryAttribute : CategoryAttribute
    {
        public SRCategoryAttribute(string stringResourceKey) : base(stringResourceKey)
        {
        }

        protected override string GetLocalizedString(string key)
        {
            return SR.Keys.GetString(key);
        }
    }
}