using System;
using System.Collections;
using System.Collections.Specialized;

namespace EAF.Security.PortalProfile
{
	[Serializable]
	public class Link
	{
		public int itemId;
		public string userId;
		public DateTime createdDate;
		public string title;
		public string url;
		public int viewOrder;
		public string description;
	}

	[Serializable]
	public class PortalProfile
	{
		private System.Collections.SortedList listLinks;

		public System.Collections.SortedList LinkList
		{
			get
			{
				if (listLinks == null)
					listLinks = new SortedList();
				return listLinks;
			}
		}
		
		internal void AddLink(int iModuleId, Link link)
		{
			ListDictionary dictLinks = Links(iModuleId);
			if (dictLinks == null)
			{
				dictLinks = new ListDictionary();
				dictLinks.Add(1,link);
			}
			else
			{
				if (link.itemId == 0)
					link.itemId = dictLinks.Count;
				if (dictLinks.Contains(link.itemId))
					dictLinks[link.itemId] = link;
				else
					dictLinks.Add(link.itemId,link);
			}

			if (LinkList.Contains(iModuleId))
				LinkList[iModuleId] = dictLinks;
			else LinkList.Add(iModuleId,dictLinks);
		}
		
		internal void AddLinks(int iModuleId, ListDictionary links)
		{
			if (LinkList.Contains(iModuleId))
				LinkList[iModuleId] = links;
			else LinkList.Add(iModuleId,links);
		}

		internal System.Collections.Specialized.ListDictionary Links(int iModuleID)
		{
			if (LinkList.Contains(iModuleID))
				return (ListDictionary)LinkList[iModuleID];
			else return null;
		}
	}
}
