using System;
using System.Security.Cryptography;

namespace SampleCryptoAlgorithms
{
	/// <summary>
	/// Summary description for DontTryThisAlgorithm
	/// </summary>
	public class DontTryThisSymmAlgorithm : SymmetricAlgorithm
	{
		// Properties
		private RNGCryptoServiceProvider RNG 
		{ 
			get
			{
				if (this._rng == null)
				{
					this._rng = new RNGCryptoServiceProvider();
				}
				return this._rng;
			}
		}

		// Fields
		private RNGCryptoServiceProvider _rng;

		public DontTryThisSymmAlgorithm()
		{
		}
	
		public override ICryptoTransform CreateDecryptor(byte[] rgbKey, byte[] rgbIV)
		{
			// TODO:  Add DontTryThisAlgorithm.CreateDecryptor implementation
			return null;
		}
	
		public override ICryptoTransform CreateDecryptor()
		{
			// TODO:  Add DontTryThisAlgorithm.CreateDecryptor implementation
			return base.CreateDecryptor ();
		}
	
		public override ICryptoTransform CreateEncryptor(byte[] rgbKey, byte[] rgbIV)
		{
			// TODO:  Add DontTryThisAlgorithm.CreateEncryptor implementation
			return null;
		}
	
		public override ICryptoTransform CreateEncryptor()
		{
			// TODO:  Add DontTryThisAlgorithm.CreateEncryptor implementation
			return base.CreateEncryptor ();
		}
	
		public override void GenerateIV()
		{
			// TODO:  Add DontTryThisAlgorithm.GenerateIV implementation
			this.IVValue = new byte[this.BlockSizeValue / 8];
			this.RNG.GetBytes(this.IVValue);
		}
	
		public override void GenerateKey()
		{
			// TODO:  Add DontTryThisAlgorithm.GenerateKey implementation
			this.KeyValue = new byte[this.KeySizeValue / 8];
			this.RNG.GetBytes(this.KeyValue);
		}
	}
}
