using System;
using System.Diagnostics;
using System.Data;
using System.Xml;

namespace XmlFileProvider
{
	/// <summary>
	/// Summary description for XmlFileTransaction.
	/// </summary>
	/// TODO: Create temporary storage to use to hold data until a commit is called; then write to file.  Otherwise, if rollback, then clear the cache
	public class XmlFileTransaction : IDbTransaction
	{
		private XmlFileConnection oConnection;
		private IsolationLevel eIsoLevel;

		public XmlFileTransaction(XmlFileConnection _Connection)
		{
			if (_Connection == null) 
				throw new ArgumentNullException("_Connection", "Connection parameter must not be null for XMLFileTransaction");
			oConnection = _Connection;
		}
	
		public XmlFileTransaction(XmlFileConnection oConnection, IsolationLevel _iso) : this(oConnection)
		{
			if (_iso.Equals(null)) 
				throw new ArgumentNullException("_iso", "IsolationLevel parameter must not be null for XMLFileTransaction");
			eIsoLevel = _iso;
		}

		#region IDbTransaction Members

		//modify this so that it clears the data in cache
		public void Rollback()
		{
		}

		//TODO: Modify this so that it writes out to the file
		public void Commit()
		{
		}

		public IDbConnection Connection
		{
			get
			{
				return oConnection;
			}
		}

		public IsolationLevel IsolationLevel
		{
			get
			{
				return !(eIsoLevel.Equals(null))? eIsoLevel : new IsolationLevel();
			}
		}

		#endregion

		#region IDisposable Members

		public void Dispose()
		{
		}

		#endregion
	}
}
